/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <errno.h>
#include "Reseau.h"
#include "Debug.h"
#include "Com/Initialisation_Com.h"
#include "Semaphore.h"
#include "Liste_Equipement.h"




	


void Get_My_MAC (void)
{
	struct ifreq ifr;
	struct sockaddr sock;
	int       Socket;

	strcpy (sock.sa_data, Info_Demarrage.Interface);
	sock.sa_family = AF_INET;
	if ((Socket = socket_control (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
	}
	ifr.ifr_addr.sa_family = AF_INET;
	sprintf (ifr.ifr_name, Info_Demarrage.Interface);
	if (ioctl (Socket, SIOCGIFHWADDR, &ifr) == -1) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
	}
	memcpy (Mon_Adresse_MAC, ifr.ifr_hwaddr.sa_data, ETH_ALEN);
	if (close_control (Socket) < 0) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
	}
	
}


void Get_My_Ip (void)
{
	struct ifreq ifr;
	struct sockaddr_in sin;
	struct sockaddr sock;
	int       Socket;

	strcpy (sock.sa_data, Info_Demarrage.Interface);
	sock.sa_family = AF_INET;
	if ((Socket = socket_control (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));

	}
	strcpy (ifr.ifr_name, Info_Demarrage.Interface);
	if (ioctl (Socket, SIOCGIFADDR, &ifr) == -1) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));

	}
	memcpy (&sin, &ifr.ifr_addr, sizeof (struct sockaddr_in));
	memcpy (Mon_Adresse_Ip, &sin.sin_addr.s_addr, IP_ADDR_LEN);
	if (close_control (Socket) < 0) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));

	}
}

unsigned short ckecksum (char *donnee, int longueur, int valeur)
{
	ERROR_if (donnee == NULL);
	int       i;
	int       somme;
	int       Nombre;

	i = 0;
	somme = 0;
	while (i < longueur) {
		if (longueur == (i + 1)) {
			donnee[i + 1] = 0;
		}
		Nombre = (((donnee[i] << 8) & 0xFF00) + (donnee[i + 1] & 0xFF));
		somme = somme + Nombre;
		i = i + 2;
	}
	while ((somme >> 16) != 0) {
		somme = (somme >> 16) + (somme & 0xffff);
	}
	somme = (0xFFFF - (somme & 0xFFFF)) - valeur;
	if ((valeur != 0) && (somme < 0))
		somme--;
	return (unsigned short) somme;
}


void ckecksum_r (struct Struct_Liste_Equipement *Equip,char *donnee, int longueur, int valeur)
{
	ERROR_if (Equip == NULL);
	ERROR_if (donnee == NULL);
	Equip->ck_i = 0;
	Equip->ck_somme = 0;
	while (Equip->ck_i < longueur) {
		if (longueur == (Equip->ck_i + 1)) {
			donnee[Equip->ck_i + 1] = 0;
		}
		Equip->ck_Nombre = (((donnee[Equip->ck_i] << 8) & 0xFF00) + (donnee[Equip->ck_i + 1] & 0xFF));
		Equip->ck_somme = Equip->ck_somme + Equip->ck_Nombre;
		Equip->ck_i = Equip->ck_i + 2;
	}
	while ((Equip->ck_somme >> 16) != 0) {
		Equip->ck_somme = (Equip->ck_somme >> 16) + (Equip->ck_somme & 0xffff);
	}
	Equip->ck_somme = (0xFFFF - (Equip->ck_somme & 0xFFFF)) - valeur;
	if ((valeur != 0) && (Equip->ck_somme < 0))
		Equip->ck_somme--;
	Equip->CheckSum_Calc = (unsigned short) Equip->ck_somme;
	return;
}


/*int waiting_service (int sock, int event)
{
	struct pollfd fds;
	int       resultat;

	bzero (&fds, sizeof fds);
	fds.events = event;
	fds.fd = sock;	
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "waiting_service : (%d)", sock);
	if ((resultat = poll (&fds, 1, 1000)) > 0) {
		if ((fds.revents & POLLERR) == POLLERR) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "waiting_service Socket error : (%d)", sock);
			return ERREUR_SOCK;
		}
		if ((fds.revents & POLLHUP) == POLLHUP) {
			debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "waiting_service Socket error : (%d)", sock);
			return ERREUR_SOCK;
		}
		debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "waiting_service : (%d) pret", sock);
		return DONNEE_PRET;
	}
	else {
		if (resultat != 0) {
			debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));
		}
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "waiting_service : (%d) Attendre 1 secondes", sock);
		return ATTENDRE;
	}
	return DONNEE_PRET;   
}*/

gboolean attendre_Donnee (int sock, int temp)
{
	fd_set fd_read,fd_write;
	socklen_t lon; 
    struct timeval tv;
	int retval,valopt,NbSeconde; 
	
	NbSeconde = 0; 
	while (NbSeconde<temp){
	
	
	
		FD_ZERO(&fd_read);
		FD_SET(sock, &fd_read);
		FD_ZERO(&fd_write);
		FD_SET(sock, &fd_write);
	
   		tv.tv_sec = 1;
    	tv.tv_usec = 0;
 		retval = select(sock + 1,&fd_read, &fd_write, NULL, &tv);
    	if (retval==2){
		
    		lon = sizeof(int); 
    		if (getsockopt(sock, SOL_SOCKET, SO_ERROR, (void*)(&valopt), &lon) < 0) {
				debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Error in getsockopt() %d - %s\n", errno, strerror(errno)); 
        		return FALSE;
			} 
			if (valopt) { 
				debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Error in delayed connection() %d - %s",valopt, strerror(valopt)); 
				return FALSE;
			} 
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Donnee presente sur la socket (%d)",sock);
			return TRUE;
		}
    	else {
			debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Aucune donnée depuis 1 secondes  retval=%d",retval);
			sleep(1);
		}
		NbSeconde++;
	}
	return FALSE;
	
	
	/*int       result;

	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Attendre_donnee  sock:(%d)", sock);
	while ((result = waiting_service (sock, POLLIN)) == ATTENDRE) {
		temp--;
		if (temp == 0) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Timeout dans Attendre_donnee");
			return FALSE;
		}
	}
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Attendre_donnee");
	if (result == ERREUR_SOCK) {
		debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Attendre_donnee (%d )Socket error : (%d)", temp, sock);
		return FALSE;
	}
	return TRUE;*/
}

void set_NonBlock (int sock,int block)
{
	int       flags;

	if (block == SOCKET_NON_BLOQUANT){
		if ((flags = fcntl (sock, F_GETFL)) == -1)
			debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));
		if (fcntl (sock, F_SETFL, flags | O_NONBLOCK) == -1)
			debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));
	}

}


gboolean connection_Serveur (unsigned char *Ip, int Port, int sock)
{
	struct sockaddr_in SocketAddr;

    ERROR_if (Ip == NULL);
	memset (&SocketAddr, 0, sizeof (struct sockaddr_in));
	if (inet_aton(Ip,&SocketAddr.sin_addr)==0)
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "inet_aton()");
	SocketAddr.sin_family = AF_INET;
	SocketAddr.sin_port = htons (Port);
	if (connect (sock, (struct sockaddr *) &SocketAddr, sizeof (struct sockaddr)) < 0) {
		if (errno != EINPROGRESS) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s : Equipement : [%s] port:[%d] ", strerror (errno), Ip, Port);
			return FALSE;
		}
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Socket avec etat en progression : [%s] port:[%d]  socket (%d)",Ip, Port,sock);
	}
	return TRUE;
}

unsigned char *resoudre_DNS (char *Serveur,unsigned char *Adresse_Ip)
{
	struct sockaddr_in SocketAddr;
		
	ERROR_if (Serveur == NULL);
	int       ret, err;
	char     *ptr = NULL;
	char      buf[1024];
	struct hostent h, *host = NULL, *hostent = NULL;
	
	PROTECT_CODE (Semaphore_DNS);
	ret = gethostbyname_r (Serveur, &h, buf, sizeof (buf), &host, &err);
	if (host == NULL) {
		switch (err) {
		    case HOST_NOT_FOUND:
			    debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "L'hôte indiqué est inconnu. [%s]", Serveur);
			    break;
		    case NO_ADDRESS:
			    debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Le nom est valide mais ne possède pas d'adresse IP. [%s]", Serveur);
			    break;
		    case NO_RECOVERY:
			    debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Une erreur fatale du serveur de noms est apparue. [%s]", Serveur);
			    break;
		    case TRY_AGAIN:
			    debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Aucune connection Ã  internet. [%s]", Serveur);
			    break;
		    default:
			    debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Erreur Inconnue [%s]", Serveur);
			    break;
		}
		DEPROTECT_CODE (Semaphore_DNS);	
		return NULL;
	}

	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Nom Officiel : %s  taille : %d \n", host->h_name, host->h_length);
	memset (&SocketAddr, 0, sizeof (struct sockaddr_in));
	memcpy (&SocketAddr.sin_addr.s_addr, host->h_addr, host->h_length);
	strcpy (Adresse_Ip, inet_ntoa (SocketAddr.sin_addr));
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Adresse resolu : %s\n",Adresse_Ip);
	DEPROTECT_CODE (Semaphore_DNS);
	return Adresse_Ip;
}

int Creation_Socket_TCP (void)
{
	int Socket_Agent;
	Socket_Agent = socket_control (AF_INET, SOCK_STREAM, 0);
	ERROR_if (Socket_Agent == -1);
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Creation d'une socket TCP/IP  (%d)", Socket_Agent);
	return Socket_Agent;
}

int Connection_Equipement (unsigned char *Ip, char *Serveur, int Port, int Tentative,int NbmilliSecondeAttente,gboolean Block)
{
	ERROR_if ((Serveur == NULL)&&(Ip == NULL));
	int       IdSocket, TimeOut;
	gboolean  Connection_Accepter;
	unsigned char *Adresse_Ip_Utiliser = NULL,Adresse_Ip_Resolu[15 + 1];
	fd_set fd_read,fd_write;
	socklen_t lon; 
    struct timeval tv;
	int retval,valopt;
	

	if (Ip == NULL) { 
	  if ((Adresse_Ip_Utiliser = resoudre_DNS (Serveur,Adresse_Ip_Resolu)) == NULL) 
		return (-1);
 	}
  	else
	  Adresse_Ip_Utiliser =Ip;

	IdSocket = Creation_Socket_TCP ();
  	if (!Block)
  		set_NonBlock(IdSocket,SOCKET_NON_BLOQUANT);

	Connection_Accepter = FALSE;
	if (connection_Serveur (Adresse_Ip_Utiliser, Port, IdSocket)){
	
		TimeOut = 0;
		do {
		
		
		
		
		
			FD_ZERO(&fd_write);
			FD_SET(IdSocket, &fd_write);
		
   			tv.tv_sec = 1;
    		tv.tv_usec = 0;
 			retval = select(IdSocket + 1,NULL,&fd_write, NULL, &tv);
    		if (retval==1){
			
    			lon = sizeof(int); 
    			if (getsockopt(IdSocket, SOL_SOCKET, SO_ERROR, (void*)(&valopt), &lon) < 0) {
					debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Error in getsockopt() %d - %s\n", errno, strerror(errno)); 
        			return FALSE;
				}
				else {
					if (valopt) { 
						debug_printf ( D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Error in delayed connection() %d - %s",valopt, strerror(valopt)); 
					}
					else {				
						debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Connection a la socket (%d)",IdSocket);
						Connection_Accepter = TRUE;
					}
				}
			}
    		else {
				debug_printf ( D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Connection impossible depuis 1 secondes  retval=%d  socket (%d)",retval,IdSocket);
				sleep(1);
			}
			
			
			/*bzero (&fds, sizeof fds);
			fds[0].events = POLLOUT;
			fds[0].fd = IdSocket;	
			if ((resultat = poll (&fds, 1, 1000)) > 0) {
				if (fds[0].revents & POLLOUT){
					debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Socket pret en ecriture");
					Connection_Accepter = TRUE;
				}
			}
			else {
				if (resultat != 0) 
					debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Socket error : (%d)  [%s]", socket,strerror (errno));
				debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Pas de données depuis 1 secondes");
			}*/
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Tentative [%s] Connection port %d : TimeOut n[%d]", Ip,Port,TimeOut);
			TimeOut++;
		} while ((!Connection_Accepter) && (TimeOut <= Tentative));
	}
	if (!Connection_Accepter) {
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Impossible de se connecter. Fermeture de la socket");
		if (close_control (IdSocket) < 0)
			debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s\nSocket ouvert[%d]  Thread[%d][%d]\n Nb equipement (%d)", strerror (errno), Nb_Socket_Ouverte, Info_Demarrage.Nb_Thread_Max, Info_Demarrage.Nb_Thread_Max - Valeur_Semaphore (&Semaphore_Thread_Scan), g_list_length (GList_Equipement));
		return -1;
	}
	return IdSocket;
}

gint create_tcp_server (int Port, int Nb_Max_Client)
{
	int       Socket, optval;
	struct sockaddr_in SocketAddr;


	if (-1 == (Socket = socket (PF_INET, SOCK_STREAM, 0)))
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));

	optval = 1;
	setsockopt (Socket, SOL_SOCKET, SO_REUSEADDR, &optval, sizeof (int));

	memset ((char *) &SocketAddr, 0, sizeof (struct sockaddr_in));
	SocketAddr.sin_family = AF_INET;
	SocketAddr.sin_port = htons (Port);
	SocketAddr.sin_addr.s_addr = htonl (INADDR_ANY);
	if (-1 == (bind (Socket, (struct sockaddr *) &SocketAddr, sizeof (struct sockaddr_in))))
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));

	if (-1 == (listen (Socket, Nb_Max_Client)))
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "%s", strerror (errno));
	return (Socket);
}
