/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __SEMAPHORE
#define         __SEMAPHORE

#include <semaphore.h>

sem_t     Semaphore_Nouveau_Equipement;
sem_t     Semaphore_Thread_Scan;
sem_t     Semaphore_Info;
sem_t     Semaphore_Equipement;
sem_t     Semaphore_Control_Usage_Socket;
sem_t     Semaphore_Debug;
sem_t     Semaphore_Notification_Equipement;
sem_t     Semaphore_Notification_Port;
sem_t     Semaphore_Snmp;
sem_t     Semaphore_Communication;
sem_t     Semaphore_DNS;
sem_t     Semaphore_Mem;
sem_t     Semaphore_WakeUp;
sem_t     Semaphore_Ping_Equipement;
sem_t     Semaphore_Etat_Thread;
sem_t     Semaphore_Thread;
sem_t     Semaphore_Scan_Arp_Sous_Reseau;
sem_t     Semaphore_Fonction_Externe;
sem_t     Semaphore_BackTrace;
sem_t     Semaphore_Log_File;

void      Attendre_Semaphore (sem_t * sem);
void      Liberation_Semaphore (sem_t * sem);
void      Initialisation_Semaphore_Gestion_Thread (void);
void      Initialisation_Semaphore (void);
int       Valeur_Semaphore (sem_t * sem);


#define PROTECT_CODE(sem)	G_STMT_START{ Attendre_Semaphore (&sem); }G_STMT_END	


#define DEPROTECT_CODE(sem)	G_STMT_START{ Liberation_Semaphore (&sem); }G_STMT_END	

#endif
