/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifdef         __NESSUS_ENABLE


#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gtk/gtk.h>

#include "Nessus_Message_Callbacks.h"
#include "Nessus_Message_Interface.h"
#include "../Declaration_Constante.h"
#include "Root_Interface.h"

GtkWidget *create_win_Nessus (void)
{
	scrolledwindow_Nessus = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Nessus);
	gtk_container_add (GTK_CONTAINER (viewport_Modules), scrolledwindow_Nessus);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Nessus), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_Nessus = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_Nessus);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Nessus), viewport_Nessus);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_Nessus), GTK_SHADOW_NONE);

	vbox_Nessus_Milieu = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Nessus_Milieu);
	gtk_container_add (GTK_CONTAINER (viewport_Nessus), vbox_Nessus_Milieu);

	scrolledwindow_Nessus_Texte = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Nessus_Texte);
	gtk_box_pack_start (GTK_BOX (vbox_Nessus_Milieu), scrolledwindow_Nessus_Texte, TRUE, TRUE, 11);
	gtk_widget_set_size_request (scrolledwindow_Nessus_Texte, 312, 136);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Nessus_Texte), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow_Nessus_Texte), GTK_SHADOW_IN);

	textview_Nessus = gtk_text_view_new ();
	gtk_widget_show (textview_Nessus);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Nessus_Texte), textview_Nessus);

	hbox_Nessus_Button = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Nessus_Button);
	gtk_box_pack_start (GTK_BOX (vbox_Nessus_Milieu), hbox_Nessus_Button, FALSE, TRUE, 6);

	fixed_Nessus_Button_Gauche = gtk_fixed_new ();
	gtk_widget_show (fixed_Nessus_Button_Gauche);
	gtk_box_pack_start (GTK_BOX (hbox_Nessus_Button), fixed_Nessus_Button_Gauche, TRUE, TRUE, 0);

	button_Nessus = gtk_button_new ();
	gtk_widget_show (button_Nessus);
	gtk_box_pack_start (GTK_BOX (hbox_Nessus_Button), button_Nessus, FALSE, FALSE, 0);
	gtk_widget_set_size_request (button_Nessus, 96, 32);

	alignment_Nessus = gtk_alignment_new (0.5, 0.5, 0, 0);
	gtk_widget_show (alignment_Nessus);
	gtk_container_add (GTK_CONTAINER (button_Nessus), alignment_Nessus);

	hbox_Nessus = gtk_hbox_new (FALSE, 2);
	gtk_widget_show (hbox_Nessus);
	gtk_container_add (GTK_CONTAINER (alignment_Nessus), hbox_Nessus);

	image_Nessus = gtk_image_new_from_stock ("gtk-close", GTK_ICON_SIZE_BUTTON);
	gtk_widget_show (image_Nessus);
	gtk_box_pack_start (GTK_BOX (hbox_Nessus), image_Nessus, FALSE, FALSE, 0);

	label_Nessus = gtk_label_new_with_mnemonic ("Close");
	gtk_widget_show (label_Nessus);
	gtk_box_pack_start (GTK_BOX (hbox_Nessus), label_Nessus, FALSE, FALSE, 0);

	fixed_Nessus_Button_Droite = gtk_fixed_new ();
	gtk_widget_show (fixed_Nessus_Button_Droite);
	gtk_box_pack_start (GTK_BOX (hbox_Nessus_Button), fixed_Nessus_Button_Droite, TRUE, TRUE, 0);

	g_signal_connect ((gpointer) button_Nessus, "clicked", G_CALLBACK (on_button_Nessus_clicked), NULL);
	return scrolledwindow_Nessus;
}


#endif
